package ru.dbotthepony.mc.otm.block.decorative

import net.minecraft.core.BlockPos
import net.minecraft.world.item.ItemStack
import net.minecraft.world.level.BlockGetter
import net.minecraft.world.level.block.EntityBlock
import net.minecraft.world.level.block.entity.BlockEntity
import net.minecraft.world.level.block.state.BlockState
import net.minecraft.world.level.storage.loot.LootParams
import net.minecraft.world.level.storage.loot.parameters.LootContextParams
import net.minecraft.world.phys.shapes.CollisionContext
import net.minecraft.world.phys.shapes.VoxelShape
import net.minecraft.world.phys.shapes.Shapes
import ru.dbotthepony.mc.otm.block.RotatableMatteryBlock
import ru.dbotthepony.mc.otm.block.entity.decorative.BreakableContainerBlockEntity
import ru.dbotthepony.mc.otm.registry.game.MBlocks
import ru.dbotthepony.mc.otm.shapes.BlockShapes

class BreakableContainerBlock(properties: Properties) : RotatableMatteryBlock(properties), EntityBlock {
	override fun newBlockEntity(pos: BlockPos, state: BlockState): BlockEntity {
		return BreakableContainerBlockEntity(pos, state)
	}

	override fun getDrops(state: BlockState, params: LootParams.Builder): MutableList<ItemStack> {
		val entity = params.getOptionalParameter(LootContextParams.BLOCK_ENTITY)

		if (entity is BreakableContainerBlockEntity)
			return entity.loot.getItems(params, state)

		return super.getDrops(state, params)
	}

	//i just nuked myself
	private val vesselShape by lazy { BlockShapes.ROFLITE_VESSEL.computeShape()}


	override fun getShape(
		state: BlockState,
		blockGetter: BlockGetter,
		pos: BlockPos,
		context: CollisionContext
	): VoxelShape {
		//невероятные костыли
		return if (state.block == MBlocks.ROFLITE_VESSEL) vesselShape
		else super.getShape(state, blockGetter, pos, context)
	}
}
